unit DSCheckBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UAboutBoxGChek,DsgnIntf;

{$R DSCHECK.Res}

type
  TGButtonState = (jlUp, jlDown, jlFixed, jlOver);
  TGCustomColor = (ccBlue,ccRed,ccGreen);
  TDSCheckBox = class(TGraphicControl)
  private
    Fabout:String;
    FEnabled: boolean;
    FCaptionMouseOver: Boolean;
    FFont: TFont;
    FCaption: string;
    FCustomColor: TGCustomColor;
    FFontColor: TColor;
    FBackgroundColor: TColor;
    FChecked: boolean;
    FDisabled:TColor;
    HiLigthColorMode:TColor;
    procedure SetFFontColor(Colore:TColor);
    procedure SetEnabled(const Value: boolean);Virtual;
    procedure SetCaptionMouseOver(const Value: Boolean);
    function getcolor(syscolor:TColor):TColor;
    procedure SetFont(const Value: TFont);
    procedure SetCaption(const Value: string);
    function IsInsideButton(X, Y: Integer): boolean;
    procedure WMMOUSEMOVE (var Message: TWMMouseMove); Message WM_MOUSEMOVE;
    procedure WMLMOUSEDOWN (var Message: TMessage); Message WM_LBUTTONDOWN;
    procedure WMLMOUSEUP (var Message: TMessage); Message WM_LBUTTONUP;
    procedure WMMOUSELEAVE (var Message: TMessage); Message CM_MOUSELEAVE;
    procedure WMSIZE (var Message: TMessage); message WM_SIZE;
    procedure SetCustomColor(const Value: TGCustomColor);
    function GetCustomColor:TColor;
    procedure SetFontColor(const Value: TColor);
    procedure SetBackgroundColor(const Value: TColor);
    procedure SetChecked(const Value: boolean);
    procedure SetAbout(const Value: String);
  protected
    FCol:integer;
    FButtonState:TGButtonState;
    FMouseDown:boolean;
    FHiLigthMode:boolean;
    FHeight:integer;
    FFontColorProperty:TColor;
    FHiLigthColor:TColor;
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published
    property BackgroundColor:TColor read FBackgroundColor write SetBackgroundColor;
    property align;
    property Caption:string read FCaption write SetCaption;
    property Enabled:boolean read FEnabled write SetEnabled;
    property Font: TFont read FFont write SetFont;
    property CustomColor:TGCustomColor read FCustomColor write SetCustomColor;
    property About:String Read Fabout Write SetAbout;
    property ShowHint;
    property Checked:boolean read FChecked write SetChecked;
    property HiLigthMode:boolean read FHiLigthMode write FHiLigthMode Stored True;
    property HiLigthColor:TColor Read FHiLigthColor Write FHiLigthColor Stored True;
    property OnClick;
    property FontColor:TColor Read FFontColorProperty Write SetFFontColor Stored True;

  end;

  TAboutProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;

implementation


//----------------------------------------------------------------

constructor TDSCheckBox.Create(AOwner: TComponent);
begin
  inherited;
  ControlStyle := ControlStyle-[csOpaque];
  Caption:='DSCheckBox';
  enabled:=true;
  FFont:=TFont.Create;
  FFont.size:=8;
  FFont.Style:=[];
  FMouseDown:=false;
  FCustomColor:=ccBlue;
  FFontColor:=clBlack;
  FFontColorProperty:=ClBlack;
  FHiLigthColor:=ClBlack;
  HiLigthColorMode:=ClBlack;
  FBackgroundColor:=clBtnFace;
  FDisabled:=clDkGray;
  FCol:=0;
  width:=97;
  height:=16;
  FHeight:=height-2;
end;

//----------------------------------------------------------------

destructor TDSCheckBox.Destroy;
begin
  inherited;
  FFont.Free;
end;

//----------------------------------------------------------------

function TDSCheckBox.GetCustomColor:TColor;
var
  gcol:TColor;
begin
  gcol:=0;
  case FCustomColor of
    ccBlue:gcol:=ClBlue;
    ccRed:gcol:=ClRed;
    ccGreen:gcol:=ClGreen;
  end;
  GetCustomColor:=gcol;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.Paint;

  Function TornaColore(Colore:TGCustomColor):String;
  Begin
    RESULT:='CHKOFF';
    If colore=CCGreen Then Result:='CHKGRE';
    If Colore=ccBlue Then Result:='CHKBLU';
    If Colore=ccRed Then Result:='CHKRED';
  End;

var
  dc:hdc;
  hand:hwnd;
  BackColor,orbcolor:TColor;
  ox,oy:integer;
  tx,ty:integer;
  bx,by:integer;
  FBuffer:tBitmap;
  FBuffer2:tBitmap;
  Corners:integer;
  FWidth:integer;
  vert:array[0..5]of TPoint;
  rgn:HRGN;
  tx2:integer;
begin
  if parent.HandleAllocated then begin
  hand:=parent.Handle;
  DC:=GetDc(hand);
  ox:=0;
  oy:=0;
  tx:=0;
  ty:=0;
  bx:=0;
  by:=0;

  Fbuffer := TBitmap.Create;
  Fbuffer.Width :=  width;
  Fbuffer.Height := height;
  Fbuffer2 := TBitmap.Create;
  Fbuffer2.Width :=  width;
  Fbuffer2.Height := height;

  FWidth:=Height;

  if Not enabled then begin
    if FChecked then
      Fbuffer.LoadFromResourceName(HInstance,'CHKDISABLEDON')
    Else
      Fbuffer.LoadFromResourceName(HInstance,'CHKDISABLEDOFF')
  End
  Else Begin
    if FChecked then
      Fbuffer.LoadFromResourceName(HInstance,TornaColore(FCustomColor))
    Else
      Fbuffer.LoadFromResourceName(HInstance,'CHKOFF')
  End;

  Canvas.Draw(0,0,FBuffer);

  if Fcaption<>'' then begin
    Canvas.Font.Name:=FFont.Name;
    Canvas.Font.Size:=FFont.Size;
    Canvas.Font.Style:=FFont.Style;
    canvas.Brush.Style := bsClear;
    ty:=(((oy+2)-Canvas.TextExtent(Fcaption).cy)div 2);
    if ty<0 then ty:=0;
    tx:=(((ox+2)-Canvas.TextExtent(Fcaption).cx)div 2);

   if Enabled then begin
    canvas.font.color:=FFontColorProperty;
      if HiLigthMode then begin
          canvas.font.color:=HiLigthColorMode;
      end;
   end
   else
    canvas.font.color:=FDisabled;

    canvas.textout(16+5,ty,Fcaption);
  end;
    bitBlt(canvas.handle,0,0,width,height,Fbuffer.canvas.handle,0,0,srccopy);


  ty:=height div 2;
  tx:=height div 4;
  tx2:=height div 8;

  releaseDC(hand,DC);
  Fbuffer.Free;
  Fbuffer2.Free;
  end;
end;

//----------------------------------------------------------------

function TDSCheckBox.getcolor(syscolor:TColor):TColor;
begin
  case sysColor of
    clBackground:SysColor:=GetSysColor(COLOR_BACKGROUND);
    clActiveCaption:SysColor:=GetSysColor(COLOR_ACTIVECAPTION);
    clInactiveCaption:SysColor:=GetSysColor(COLOR_INACTIVECAPTION);
    clMenu:SysColor:=GetSysColor(COLOR_MENU);
    clWindow:SysColor:=GetSysColor(COLOR_WINDOW);
    clWindowFrame:SysColor:=GetSysColor(COLOR_WINDOWFRAME);
    clMenuText:SysColor:=GetSysColor(COLOR_MENUTEXT);
    clWindowText:SysColor:=GetSysColor(COLOR_WINDOWTEXT);
    clCaptionText:SysColor:=GetSysColor(COLOR_CAPTIONTEXT);
    clActiveBorder:SysColor:=GetSysColor(COLOR_ACTIVEBORDER);
    clInactiveBorder:SysColor:=GetSysColor(COLOR_INACTIVEBORDER);
    clAppWorkspace:SysColor:=GetSysColor(COLOR_APPWORKSPACE);
    clHighlight:SysColor:=GetSysColor(COLOR_HIGHLIGHT);
    clHighlightText:SysColor:=GetSysColor(COLOR_HIGHLIGHTTEXT);
    clBtnFace:SysColor:=GetSysColor(COLOR_BTNFACE);
    clBtnShadow:SysColor:=GetSysColor(COLOR_BTNSHADOW);
    clGrayText:SysColor:=GetSysColor(COLOR_GRAYTEXT);
    clBtnText:SysColor:=GetSysColor(COLOR_BTNTEXT);
    clInactiveCaptionText:SysColor:=GetSysColor(COLOR_INACTIVECAPTIONTEXT);
    clBtnHighlight:SysColor:=GetSysColor(COLOR_BTNHIGHLIGHT);
    cl3dDkShadow:SysColor:=GetSysColor(COLOR_3DDKSHADOW);
    cl3dLight:SysColor:=GetSysColor(COLOR_3DLIGHT);
    clInfoBk:SysColor:=GetSysColor(COLOR_INFOBK);
    clInfoText:SysColor:=GetSysColor(COLOR_INFOTEXT);
  end;
  GetColor:=syscolor;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.SetCaptionMouseOver(const Value: Boolean);
begin
  FCaptionMouseOver := Value;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.SetEnabled(const Value: boolean);
begin
  FEnabled := Value;
  invalidate;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.SetFont(const Value: TFont);
begin
  FFont.Assign(Value);
  invalidate;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.SetCaption(const Value: string);
begin
  FCaption := Value;
  invalidate;
end;

//----------------------------------------------------------------

function TDSCheckBox.IsInsideButton(X, Y: Integer): boolean;
var
  BtnEllipse : HRgn;
begin

  BtnEllipse:= createRoundRectRgn(2,2,width-1,height-2,8,8);
  Result := PtInRegion(BtnEllipse,X,Y);
  DeleteObject(BtnEllipse);
end;

//----------------------------------------------------------------

procedure TDSCheckBox.WMLMOUSEDOWN(var Message: TMessage);
var
  mousepos:TPoint;
  temp:TGButtonState;
begin

  GetCursorPos(MousePos);
  MousePos:=ScreenToClient(MousePos);

  if (Enabled and IsInsideButton(mousepos.X,mousepos.Y)) then begin
    temp:=FButtonState;
    FButtonState:=jlDown;
    if temp<>FButtonState then paint;
  end;
  FMouseDown:=true;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.WMLMOUSEUP(var Message: TMessage);
begin

  inherited;
  if enabled then if FMouseDown then begin
    FButtonState:=jlUp;
    FMouseDown:=false;
    FChecked:=not(FChecked);
    invalidate;
    click;
  end;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.WMMOUSEMOVE(var Message: TWMMouseMove);
var
  temp:TGButtonState;
  mousepos:TPoint;
begin

  GetCursorPos(MousePos);
  MousePos:=ScreenToClient(MousePos);
  HiLigthColorMode:=FHiLigthColor;
  if (FmouseDown)then begin
    if enabled then begin
      temp:=FButtonState;
      if IsInsideButton(mousepos.x,mousepos.y) then FButtonState:=jldown else FButtonState:=jlUp;
      if temp<>FButtonState then paint;
    end;
  end else if (enabled) then begin
    temp:=FButtonState;
    if IsInsideButton(mousepos.x,mousepos.y) then begin
      FButtonState:=jlover
    end else begin
      FButtonState:=jlUp;
    end;
    if temp<>FButtonState then paint;
  end;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.SetCustomColor(const Value: TGCustomColor);
begin
  FCustomColor := Value;
  invalidate;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.SetFontColor(const Value: TColor);
begin
  FFontColor := Value;
  invalidate;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.WMMOUSELEAVE(var Message: TMessage);
var
  temp:TGButtonState;
begin
  HiLigthColorMode:=FFontColorProperty;
  temp:=FButtonState;
  FButtonState:=jlUp;
  FmouseDown:=false;
  if (temp<>FButtonState) or (FHiLigthMode=true) then paint;

end;

//----------------------------------------------------------------

procedure TDSCheckBox.SetBackgroundColor(const Value: TColor);
begin
  FBackgroundColor := Value;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.WMSIZE(var Message: TMessage);
begin
  height:=21;
  FHeight:=height-2;
  invalidate;
end;

//----------------------------------------------------------------

procedure TDSCheckBox.SetChecked(const Value: boolean);
begin
  FChecked := Value;
  invalidate;
end;


//----------------------------------------------------------------

procedure TDSCheckBox.SetFFontColor(Colore:TColor);
begin
  FFontColorProperty := Colore;
  invalidate;
end;

//----------------------------------------------------------------

Procedure TDSCheckBox.SetAbout(const Value: String);
Begin
  Fabout:='';
  AboutBox:=TAboutBox.create(Application);
  AboutBox.showmodal;
  AboutBox.Release;
  AboutBox:=Nil;
End;
//----------------------------------------------------------------

procedure TAboutProperty.Edit;
Begin
SetValue('');
End;

//----------------------------------------------------------------

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure Register;
begin
  RegisterComponents('DigitStudios', [TDSCheckBox]);
  RegisterPropertyEditor(TypeInfo(String), TDSCheckBox, 'About', TAboutProperty);
end;

end.
